// JTHookKeyHook.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "JTPlugin.h"
#include "HookKeyHookApp.h"

/* Global Variables */
static HMODULE			gs_hModule	= NULL;
static CHookKeyHookApp*	gs_pApp		= NULL;


BOOL
APIENTRY
DllMain(
	HANDLE hModule, 
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		gs_hModule = (HMODULE)hModule;
		break;
	case DLL_PROCESS_DETACH:
		if (gs_pApp != NULL) {
			gs_pApp->Stop();
			gs_pApp->Terminate();
			delete gs_pApp;
			gs_pApp = NULL;
		}
		gs_hModule = NULL;
		break;
	}
    return TRUE;
}


DLLEXPORT
DWORD
JTEvent_PermitSpecVersion()
{
	return MAKEVERSION(MAJOR, MINOR, BUILD, REVISION);
}


DLLEXPORT
BOOL
JTEvent_Init(
	 HMODULE hJoeTune
)
{
	BOOL				bRet;
	CHookKeyHookApp*	pApp = NULL;

	bRet = FALSE;

	if (gs_pApp == NULL) {
		pApp = new CHookKeyHookApp();
		if (pApp != NULL) {
			if (pApp->Initialize(gs_hModule)) {
				if (pApp->Start()) {
					gs_pApp = pApp;
					bRet = TRUE;
				}
				else {
					pApp->Terminate();
					delete pApp;
					pApp = NULL;
				}
			}
			else {
				delete pApp;
				pApp = NULL;
			}
		}
	}

	return bRet;
}


DLLEXPORT
void
JTEvent_Close()
{
	if (gs_pApp != NULL) {
		gs_pApp->Stop();
		gs_pApp->Terminate();
		delete gs_pApp;
		gs_pApp = NULL;
	}
}

